package markov;


import markov.stuff.Utils;

import java.nio.ByteBuffer;
import java.util.Base64;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ShortenerByte64Impl extends ShortenerSimpleImpl {


    public ShortenerByte64Impl(Data data) {
        super(data);
    }

    String fromInts(Stream<Integer> ints) {
        List<Byte> bl = ints.flatMap(i -> {
            if (i < 64) {
                return Stream.of((byte) (i | 0b01000000));
            } else {
                Stream.Builder<Byte> builder = Stream.<Byte>builder();
                for (byte b : Utils.toByteArray(i)) {
                    builder.add(b);
                }
                return builder.build();
            }
        }).collect(Collectors.toList());
        ByteBuffer bb = ByteBuffer.allocate(bl.size());
        for (Byte b : bl) {
            bb.put(b);
        }
        bb.rewind();
        return Base64.getEncoder().encodeToString(bb.array());
    }

}
