package markov;

import markov.stuff.Utils;

import java.nio.ByteBuffer;
import java.util.Base64;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ShortenerByteImpl extends ShortenerSimpleImpl {


    public ShortenerByteImpl(Data data) {
        super(data);
    }

    String fromInts(Stream<Integer> ints) {
        List<Byte> bl = ints.flatMap(i -> {
            if (i < 128) {
                return Stream.of((byte) (i | 0b10000000));
            } else {
                Stream.Builder<Byte> builder = Stream.<Byte>builder();
                for (byte b : Utils.toByteArray(i)) {
                    builder.add(b);
                }
                return builder.build();
            }
        }).collect(Collectors.toList());
        ByteBuffer bb = ByteBuffer.allocate(bl.size());
        for (Byte b : bl) {
            bb.put(b);
        }
        bb.rewind();
        return Base64.getUrlEncoder().encodeToString(bb.array());
    }

    @Override
    Stream<Integer> toInts(String hash) {
        byte[] hashBytes = Base64.getUrlDecoder().decode(hash);
        Stream.Builder<Integer> builder = Stream.builder();
        for (int i = 0; i < hashBytes.length; ) {
            if (hashBytes[i] < 128) {
                builder.add((int) hashBytes[i++]);
            } else {
                byte[] newBytes = new byte[4];
                System.arraycopy(hashBytes, i, newBytes, 0, 4);
                builder.add(Utils.fromByteArray(newBytes));
                i += 4;
            }
        }
        return builder.build();
    }
}
